// ctd.cpp

// Includes
#include "ctd.h"

// Konstruktor
CCtd::CCtd( void )
{
	memset( this, 0, sizeof(CCtd) );

	// DLL laden
	#ifdef CTD1x
	m_hInst = LoadLibrary( "CDLLI15.DLL" );
	if ( !m_hInst )
		m_hInst = LoadLibrary( "CDLLI11.DLL" );
	#endif

	#ifdef CTD2x	
	m_hInst = LoadLibrary( "CDLLI21.DLL" );
	if ( !m_hInst )
		m_hInst = LoadLibrary( "CDLLI20.DLL" );
	#endif

	#ifdef CTD3x	
	m_hInst = LoadLibrary( "CDLLI30.DLL" );
	#endif

	if ( m_hInst )
	{
		ArrayDimCount = (SALARRAYDIMCOUNT)GetProcAddress( m_hInst, "SalArrayDimCount" );
		ArrayGetLowerBound = (SALARRAYGETLOWERBOUND)GetProcAddress( m_hInst, "SalArrayGetLowerBound" );
		ArrayGetUpperBound = (SALARRAYGETUPPERBOUND)GetProcAddress( m_hInst, "SalArrayGetUpperBound" );
		ArrayIsEmpty = (SALARRAYISEMPTY)GetProcAddress( m_hInst, "SalArrayIsEmpty" );
		ColorGet = (SALCOLORGET)GetProcAddress( m_hInst, "SalColorGet" );
		CompileAndEvaluate = (SALCOMPILEANDEVALUATE)GetProcAddress( m_hInst, "SalCompileAndEvaluate" );
		ContextCurrent = (SALCONTEXTCURRENT)GetProcAddress( m_hInst, "SalContextCurrent" );
		DateToStr = (SALDATETOSTR)GetProcAddress( m_hInst, "SalDateToStr" );
		DisableWindow = (SALDISABLEWINDOW)GetProcAddress( m_hInst, "SalDisableWindow" );
		EnableWindow = (SALENABLEWINDOW)GetProcAddress( m_hInst, "SalEnableWindow" );
		FmtGetPicture = (SALFMTGETPICTURE)GetProcAddress( m_hInst, "SalFmtGetPicture" );
		FormUnitsToPixels = (SALFORMUNITSTOPIXELS)GetProcAddress( m_hInst, "SalFormUnitsToPixels" );
		GetDataType = (SALGETDATATYPE)GetProcAddress( m_hInst, "SalGetDataType" );
		GetItemName = (SALGETITEMNAME)GetProcAddress( m_hInst, "SalGetItemName" );
		GetMaxDataLength = (SALGETMAXDATALENGTH)GetProcAddress( m_hInst, "SalGetMaxDataLength" );
		GetType = (SALGETTYPE)GetProcAddress( m_hInst, "SalGetType" );
		GetVersion = (SALGETVERSION)GetProcAddress( m_hInst, "SalGetVersion" );
		HStringUnRef = (SALHSTRINGUNREF)GetProcAddress( m_hInst, "SalHStringUnRef" );
		InvalidateWindow = (SALINVALIDATEWINDOW)GetProcAddress( m_hInst, "SalInvalidateWindow" );
		IsWindowEnabled = (SALISWINDOWENABLED)GetProcAddress( m_hInst, "SalIsWindowEnabled" );
		IsWindowVisible = (SALISWINDOWVISIBLE)GetProcAddress( m_hInst, "SalIsWindowVisible" );
		ParentWindow = (SALPARENTWINDOW)GetProcAddress( m_hInst, "SalParentWindow" );
		PicGetString = (SALPICGETSTRING)GetProcAddress( m_hInst, "SalPicGetString" );
		PixelsToFormUnits = (SALPIXELSTOFORMUNITS)GetProcAddress( m_hInst, "SalPixelsToFormUnits" );
		SetWindowLoc = (SALSETWINDOWLOC)GetProcAddress( m_hInst, "SalSetWindowLoc" );
		SetWindowSize = (SALSETWINDOWSIZE)GetProcAddress( m_hInst, "SalSetWindowSize" );
		StatusSetText = (SALSTATUSSETTEXT)GetProcAddress( m_hInst, "SalStatusSetText" );
		StrIsValidNumber = (SALSTRISVALIDNUMBER)GetProcAddress( m_hInst, "SalStrIsValidNumber" );
		StrToDate = (SALSTRTODATE)GetProcAddress( m_hInst, "SalStrToDate" );
		StrToNumber = (SALSTRTONUMBER)GetProcAddress( m_hInst, "SalStrToNumber" );
		UpdateWindow = (SALUPDATEWINDOW)GetProcAddress( m_hInst, "SalUpdateWindow" );

		TblAnyRows = (SALTBLANYROWS)GetProcAddress( m_hInst, "SalTblAnyRows" );
		TblFetchRow = (SALTBLFETCHROW)GetProcAddress( m_hInst, "SalTblFetchRow" );
		TblFindNextRow = (SALTBLFINDNEXTROW)GetProcAddress( m_hInst, "SalTblFindNextRow" );
		TblFindPrevRow = (SALTBLFINDPREVROW)GetProcAddress( m_hInst, "SalTblFindPrevRow" );
		TblGetColumnText = (SALTBLGETCOLUMNTEXT)GetProcAddress( m_hInst, "SalTblGetColumnText" );
		TblGetColumnTitle = (SALTBLGETCOLUMNTITLE)GetProcAddress( m_hInst, "SalTblGetColumnTitle" );
		TblGetColumnWindow = (SALTBLGETCOLUMNWINDOW)GetProcAddress( m_hInst, "SalTblGetColumnWindow" );
		TblKillEdit = (SALTBLKILLEDIT)GetProcAddress( m_hInst, "SalTblKillEdit" );
		TblKillFocus = (SALTBLKILLFOCUS)GetProcAddress( m_hInst, "SalTblKillFocus" );
		TblObjectsFromPoint = (SALTBLOBJECTSFROMPOINT)GetProcAddress( m_hInst, "SalTblObjectsFromPoint" );
		TblQueryCheckBoxColumn = (SALTBLQUERYCHECKBOXCOLUMN)GetProcAddress( m_hInst, "SalTblQueryCheckBoxColumn" );
		TblQueryColumnCellType = (SALTBLQUERYCOLUMNCELLTYPE)GetProcAddress( m_hInst, "SalTblQueryColumnCellType" );
		TblQueryColumnFlags = (SALTBLQUERYCOLUMNFLAGS)GetProcAddress( m_hInst, "SalTblQueryColumnFlags" );
		TblQueryColumnID = (SALTBLQUERYCOLUMNID)GetProcAddress( m_hInst, "SalTblQueryColumnID" );
		TblQueryColumnPos = (SALTBLQUERYCOLUMNPOS)GetProcAddress( m_hInst, "SalTblQueryColumnPos" );
		TblQueryColumnWidth = (SALTBLQUERYCOLUMNWIDTH)GetProcAddress( m_hInst, "SalTblQueryColumnWidth" );
		TblQueryContext = (SALTBLQUERYCONTEXT)GetProcAddress( m_hInst, "SalTblQueryContext" );
		TblQueryFocus = (SALTBLQUERYFOCUS)GetProcAddress( m_hInst, "SalTblQueryFocus" );
		TblQueryLinesPerRow = (SALTBLQUERYLINESPERROW)GetProcAddress( m_hInst, "SalTblQueryLinesPerRow" );
		TblQueryLockedColumns = (SALTBLQUERYLOCKEDCOLUMNS)GetProcAddress( m_hInst, "SalTblQueryLockedColumns" );
		TblQueryRowFlags = (SALTBLQUERYROWFLAGS)GetProcAddress( m_hInst, "SalTblQueryRowFlags" );
		TblQueryRowHeader = (SALTBLQUERYROWHEADER)GetProcAddress( m_hInst, "SalTblQueryRowHeader" );
		TblQueryScroll = (SALTBLQUERYSCROLL)GetProcAddress( m_hInst, "SalTblQueryScroll" );
		TblQuerySplitWindow = (SALTBLQUERYSPLITWINDOW)GetProcAddress( m_hInst, "SalTblQuerySplitWindow" );
		TblQueryTableFlags = (SALTBLQUERYTABLEFLAGS)GetProcAddress( m_hInst, "SalTblQueryTableFlags" );
		TblQueryVisibleRange = (SALTBLQUERYVISIBLERANGE)GetProcAddress( m_hInst, "SalTblQueryVisibleRange" );
		TblScroll = (SALTBLSCROLL)GetProcAddress( m_hInst, "SalTblScroll" );
		TblSetColumnText = (SALTBLSETCOLUMNTEXT)GetProcAddress( m_hInst, "SalTblSetColumnText" );
		TblSetColumnTitle = (SALTBLSETCOLUMNTITLE)GetProcAddress( m_hInst, "SalTblSetColumnTitle" );
		TblSetColumnWidth = (SALTBLSETCOLUMNWIDTH)GetProcAddress( m_hInst, "SalTblSetColumnWidth" );
		TblSetContext = (SALTBLSETCONTEXT)GetProcAddress( m_hInst, "SalTblSetContext" );
		TblSetFocusCell = (SALTBLSETFOCUSCELL)GetProcAddress( m_hInst, "SalTblSetFocusCell" );
		TblSetFocusRow = (SALTBLSETFOCUSROW)GetProcAddress( m_hInst, "SalTblSetFocusRow" );
		TblSetRowFlags = (SALTBLSETROWFLAGS)GetProcAddress( m_hInst, "SalTblSetRowFlags" );
		TblSetTableFlags = (SALTBLSETTABLEFLAGS)GetProcAddress( m_hInst, "SalTblSetTableFlags" );

		CvtDoubleToNumber = (SWINCVTDOUBLETONUMBER)GetProcAddress( m_hInst, "SWinCvtDoubleToNumber" );
		CvtLongToNumber = (SWINCVTLONGTONUMBER)GetProcAddress( m_hInst, "SWinCvtLongToNumber" );
		CvtNumberToDouble = (SWINCVTNUMBERTODOUBLE)GetProcAddress( m_hInst, "SWinCvtNumberToDouble" );
		CvtNumberToInt = (SWINCVTNUMBERTOINT)GetProcAddress( m_hInst, "SWinCvtNumberToInt" );
		CvtNumberToULong = (SWINCVTNUMBERTOULONG)GetProcAddress( m_hInst, "SWinCvtNumberToULong" );
		CvtNumberToWord = (SWINCVTNUMBERTOWORD)GetProcAddress( m_hInst, "SWinCvtNumberToWord" );
		CvtULongToNumber = (SWINCVTULONGTONUMBER)GetProcAddress( m_hInst, "SWinCvtULongToNumber" );
		InitLPHSTRINGParam = (SWININITLPHSTRINGPARAM)GetProcAddress( m_hInst, "SWinInitLPHSTRINGParam" );
		MDArrayGetHandle = (SWINMDARRAYGETHANDLE)GetProcAddress( m_hInst, "SWinMDArrayGetHandle" );
		MDArrayGetHString = (SWINMDARRAYGETHSTRING)GetProcAddress( m_hInst, "SWinMDArrayGetHString" );
		MDArrayGetNumber = (SWINMDARRAYGETNUMBER)GetProcAddress( m_hInst, "SWinMDArrayGetNumber" );
		MDArrayPutHandle = (SWINMDARRAYPUTHANDLE)GetProcAddress( m_hInst, "SWinMDArrayPutHandle" );
		MDArrayPutHString = (SWINMDARRAYPUTHSTRING)GetProcAddress( m_hInst, "SWinMDArrayPutHString" );
		MDArrayPutNumber = (SWINMDARRAYPUTNUMBER)GetProcAddress( m_hInst, "SWinMDArrayPutNumber" );
		StringGetBuffer = (SWINSTRINGGETBUFFER)GetProcAddress( m_hInst, "SWinStringGetBuffer" );

		LogLine = (SALLOGLINE)GetProcAddress( m_hInst, "SalLogLine" );
		ResId = (SALRESID)GetProcAddress( m_hInst, "SalResId" );
		ResLoad = (SALRESLOAD)GetProcAddress( m_hInst, "SalResLoad" );
	}
	else
	{
		MessageBox( NULL, "Gupta runtime environment could not be loaded.", "MICSTO", MB_ICONSTOP | MB_OK );
		return;
	}

	m_Initialized = ArrayDimCount &&
					ArrayGetLowerBound &&
					ArrayGetUpperBound &&
					ArrayIsEmpty &&
					ColorGet &&
					CompileAndEvaluate &&
					ContextCurrent &&
					DateToStr &&
					DisableWindow &&
					EnableWindow &&
					FmtGetPicture &&
					FormUnitsToPixels &&
					GetDataType &&
					GetItemName &&
					GetMaxDataLength &&
					GetType &&
					GetVersion &&
					HStringUnRef &&
					InvalidateWindow &&
					IsWindowEnabled &&
					IsWindowVisible &&
					ParentWindow &&
					PicGetString &&
					PixelsToFormUnits &&
					StatusSetText &&
					SetWindowLoc &&
					SetWindowSize &&
					StrIsValidNumber &&
					StrToDate &&
					StrToNumber &&
					UpdateWindow &&

					TblAnyRows &&
					TblFetchRow &&
					TblFindNextRow &&
					TblFindPrevRow &&
					TblGetColumnText &&
					TblGetColumnTitle &&
					TblGetColumnWindow &&
					TblKillEdit &&
					TblKillFocus &&
					TblQueryCheckBoxColumn &&
					TblObjectsFromPoint &&
					TblQueryColumnCellType &&
					TblQueryColumnFlags &&
					TblQueryColumnID &&
					TblQueryColumnPos &&
					TblQueryColumnWidth &&
					TblQueryContext &&
					TblQueryFocus &&
					TblQueryLinesPerRow &&
					TblQueryLockedColumns &&
					TblQueryRowFlags &&
					TblQueryRowHeader &&
					TblQueryScroll &&
					TblQuerySplitWindow &&
					TblQueryTableFlags &&
					TblQueryVisibleRange &&
					TblScroll &&
					TblSetColumnText &&
					TblSetColumnTitle &&
					TblSetColumnWidth &&
					TblSetContext &&
					TblSetFocusCell &&
					TblSetFocusRow &&
					TblSetRowFlags &&
					TblSetTableFlags &&

					CvtDoubleToNumber &&
					CvtLongToNumber &&
					CvtNumberToDouble &&
					CvtNumberToInt &&
					CvtNumberToULong &&
					CvtNumberToWord &&
					CvtULongToNumber &&
					InitLPHSTRINGParam &&
					MDArrayGetHandle &&
					MDArrayGetHString &&
					MDArrayGetNumber &&
					MDArrayPutHandle &&
					MDArrayPutHString &&
					MDArrayPutNumber &&
					StringGetBuffer &&

					LogLine &&
					ResId &&
					ResLoad;

	if ( !m_Initialized )
		MessageBox( NULL, "Not all required Gupta functions could be loaded.", "MICSTO", MB_ICONSTOP | MB_OK );
}


// Destruktor
CCtd::~CCtd( void )
{
	if ( m_hInst )
	{
		FreeLibrary( m_hInst );
		m_hInst = NULL;
	}
}